# ... modify DMCFG and deploy it

## Modifying DMCFG

DMCFG (read [Domain Master Configuration Reference](/data-one-installation-manager/install-data-mover-+-data-watcher-+-data-shaper/data-one-domain-master-configuration-reference.md) for details) is a YAML file located on the Data One Control Node in **\<DOIM\_HOME>/config/dmcfg.yaml**.

You may need to modify it for two reasons:

1. To alter an existing variable value.
2. To inject a new configuration parameter into the **Extended Configuration** section.

**Before starting, read this section about the YAML syntax carefully**

DMCFG is a YAML file. YAML is a formal language. When editing a YAML file with an editor that does not provide YAML syntax checking, you must be aware of these **typical mistakes**:

* Improper Indentation
  * YAML uses indentation to represent the structure of the data. Inconsistent indentation can lead to errors in parsing the data.
  * **Indentation in dmcfg.yaml is done with two space characters!**&#x20;
* Mixing Tabs and Spaces
* YAML does NOT allow mixing of tabs and spaces for indentation.
  * **Indentation in dmcfg.yaml is done with two space characters**. NEVER use tabs in this file!&#x20;
* Incorrect use of Colons
  * YAML uses colons to separate keys from their corresponding values.
* Misspelled Keywords
  * YAML has a set of predefined keywords, such as "true", "false", "null", etc.
* Missing or Extra Commas
  * YAML uses commas to separate items in a list or key-value pairs.
* Improper Quoting
  * YAML allows strings to be quoted or unquoted. It is important to use quotes appropriately

{% hint style="warning" %}
You can find more information in the YAML reference resources: [YAML Ain’t Markup Language](https://yaml.org/spec/1.2.2/).
{% endhint %}

### Altering an existing parameter value

In order to alter an existing parameter, simply edit DMCFG and change its value, then proceed to deploy the change as described at the end of this topic page.

Not all existing parameters can be modified after the initial installation. **Change only those that are explicitly mentioned as modifiable in the product documentation**.

### Injecting a new parameter into Extended Configuration

The DMCFG YAML document generated by the installation process also contains an empty **Extended Configuration** section named **ext\_cfg**.

```yaml
############################################################################
#
#                   Extended configuration (optional)
#
ext_cfg:


```

This section is meant to receive additional tuning directives and special configurations. These settings will be manually added to DMCFG after the initial configuration.

Each injected setting is a name value pair as the one shown below:

```yaml
############################################################################
#
#                   Extended configuration (optional)
#
ext_cfg:
  my_new_key_name: my_new_key_value
  my_other_new_key_name: my_other_new_key_value

```

Product documentation and/or Primeur technical support agents will direct you to specific settings for specific purposes.

## Deploying a modified DMCFG

Once you are satisfied with your changes to **dmcfg.yaml**, you can proceed to deploy those changes on the affected managed nodes by running the **doim.sh domain-deploycfg** command.

This command will analyze the changes, determine which managed nodes are affected, and deploy the changes to them.

Actual changes will become effective after Data One is stopped and started again on each affected node.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.primeur.com/data-mover-1.21/how-to.../...-modify-dmcfg-and-deploy-it.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
